﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Optimization;
using System;
using System.Collections.Generic;

namespace HeuristicLab.OptimizationExpertSystem.Common {
  public class FixedRankModel : IRecommendationModel {
    private List<Tuple<IAlgorithm, double>> ranking;

    public FixedRankModel(IEnumerable<Tuple<IAlgorithm, double>> ranking) {
      this.ranking = new List<Tuple<IAlgorithm, double>>();
      foreach (var r in ranking) this.ranking.Add(r);
    }
 
    public IEnumerable<Tuple<IAlgorithm, double>> GetRanking(KnowledgeCenter kc) { 
      if (kc.Problem.ProblemId == -1) return new Tuple<IAlgorithm, double>[0];
      return ranking;
    }

    public static FixedRankModel GetEmpty() {
      return new FixedRankModel(new Tuple<IAlgorithm, double>[0]);
    }
  }
}
