﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Common.Resources;
using HeuristicLab.MainForm.WindowsForms;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;

namespace HeuristicLab.OptimizationExpertSystem.Menu {
  internal class PerformanceModelingMenuItem : MenuItemBase {
    public override Image Image { get { return VSImageLibrary.Event; } }

    public override string Name {
      get { return "Performance Modeling"; }
    }

    public override IEnumerable<string> Structure {
      get { return new[] { "Solving" }; }
    }

    public override int Position {
      get { return 210; }
    }

    public override string ToolTipText { get { return "Modeling algorithm performance to suggest well-suited instances."; } }

    public override void Execute() {
      var viewType = typeof(PerformanceModelingView);
      var view = MainForm.Views.FirstOrDefault(x => viewType == ((x is ViewHost) ? ((ViewHost)x).ActiveView : x).GetType());
      if (view != null) view.Show();
      else MainForm.ShowContent(MainForm.ExpertSystem, viewType);
    }
  }
}
